﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using Telerik.Windows.Controls.GanttView;
using Telerik.Windows.Core;

namespace RadGanttViewSample
{
    public class MyViewModel : PropertyChangedBase
    {
        private ObservableCollection<GanttTask> tasks;
        public ObservableCollection<GanttTask> Tasks
        {
            get
            {
                return tasks;
            }
            set
            {
                tasks = value;
                OnPropertyChanged(() => Tasks);
            }
        }

        public MyViewModel()
        {
            var date = DateTime.Now;

            var ganttAPI = new GanttTask() { Start = date, End = date.AddDays(2), Title = "Design public API" };
            var ganttRendering = new GanttTask() { Start = date.AddDays(2).AddHours(8), End = date.AddDays(4), Title = "Gantt Rendering" };
            var ganttDemos = new GanttTask() { Start = date.AddDays(5), End = date.AddDays(7), Title = "Gantt Demos" };

            

            ganttRendering.Dependencies.Add(new Dependency() { FromTask = ganttAPI });
            ganttDemos.Dependencies.Add(new Dependency() { FromTask = ganttRendering });

            var iterationTask = new GanttTask(date, date.AddDays(7), "Iteration 1")
            {
                Children = { ganttAPI, ganttRendering, ganttDemos }
            };

            var gantt = new GanttTask() { Start = date.AddDays(3), End = date.AddDays(5), Title = "Design public API" };
            gantt.Dependencies.Add(new Dependency { FromTask = iterationTask });

            var g = new GanttTask() { Start = date, End = date.AddDays(2), Title = "Design public API" };

            this.Tasks = new ObservableCollection<GanttTask>() { g, iterationTask };

            
        }

        public static ObservableCollection<GanttTask> ExpandItems(GanttTask item)
        {
            var criticalItems = new ObservableCollection<GanttTask>();

            criticalItems.Add(item);

            if (item.Children.OfType<IGanttTask>().Any())
            {
                var children = item.Children.OfType<IGanttTask>();

                foreach (var child in children)
                {
                    criticalItems.Add(child as GanttTask);
                }
            }

            return criticalItems;
        }


    }
}
